package com.ultimeth.util;

import java.util.*;

//==================================================================================================
/** ToIterable
 *
 *  @version    2005.08.25
 *  @author     Copyright © 2005 by Dean K. Gibson.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, version 2 of the License.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* In some cases this class can be replaced by:
 *  @SuppressWarnings( "unchecked" )
 *  ArrayList <T> list = Collections.list( Enumeration <T> enumeration );
 */

public class ToIterable <T> implements Iterable <T> {
    Enumeration <T> enumeration;

    //----------------------------------------------------------------------------------------------
    public ToIterable( Enumeration <T> enumeration ){
        this.enumeration = enumeration;
    } // ToIterable constructor

    //----------------------------------------------------------------------------------------------
    public Iterator <T> iterator(){
        return new Iterator <T>(){
            public boolean hasNext() {
                return enumeration.hasMoreElements();
            }

            public T next(){
                return enumeration.nextElement();
            }

            public void remove(){
                throw new UnsupportedOperationException();
            }
        };
    } // ToIterable.iterator

} // class ToIterable
